#!-----------------------------------------------------------------------------------------------------------------------
#TEMPLATE(FiveO,'FiveO Template'),Family('cw20'),Family('ABC')
#!-----------------------------------------------------------------------------------------------------------------------
#!
#!	FiveO Template Copyright (c) 2022 by Donald Ridley
#!
#!-----------------------------------------------------------------------------------------------------------------------
#SYSTEM
  #EQUATE(%FiveOTPLVersion,'1.01')
#Include('FiveOGroups.tpw')
#Group(%GeneralLogoHeader)
  #Boxed,Section
    #Image('FiveOTemplates.bmp'),at(10)
    #Display('Donald Ridley<39>s FiveO Template'),at(,90),prop(PROP:FontStyle,700)
    #Display('Version ' & %FiveOTPLVersion),prop(PROP:FontStyle,700)
  #EndBoxed
#Group(%GeneralNoObjectOption)
  #Boxed('Debugging'),section,at(,,,28)
    #Prompt('Do Not Generate This Object',check),%NoThisObj, at(10,4)
  #EndBoxed
#Group(%GeneralExtensionInfo)
#!-----------------------------------------------------------------------------------------------------------------------
#Extension(Activate_FiveO,'Activate FiveO - Version:1.01'),Application
#!-----------------------------------------------------------------------------------------------------------------------
#PREPARE
  #Declare(%yep)
  #Set(%yep,0)
  #CALL(%ReadABCFiles(ABC))              #! Loads ABC Classes if not already loaded
  #FOR(%pClassName)
    #IF(sub(%pClassName,1,3)='Net')
      #Set(%yep,1)
      #BREAK
    #ENDIF
  #ENDFOR
  #IF (%Yep=0)
    #CALL(%ForceReadABCFiles(ABC))       #! The net Classes might have been suppressed
  #ENDIF
#ENDPREPARE
#!-----------------------------------------------------------------------------------------------------------------------
#Sheet
 #Tab('General')
   #Insert(%GeneralLogoHeader)
   #Boxed(' Debugging '),section,at(,,,28)
     #Prompt('Disable All FiveO Features',Check),%NoFiveO,At(10,4)
   #EndBoxed
 #EndTab
#EndSheet
#!-----------------------------------------------------------------------------------------------------------------------
#EXTENSION(GlobalTableUseTracker,'Global FiveO Table Use Tracker'),Application,Req(Activate_FiveO(FiveO))
#!-----------------------------------------------------------------------------------------------------------------------
  #sheet
    #TAB('General')
      #BOXED
        #DISPLAY('')
        #DISPLAY('This global extension adds a glabal Queue and Class ')
        #DISPLAY('that tracks everytime a table is used.')
        #DISPLAY('')
      #ENDBOXED
    #ENDTAB
    #Tab('Options')
        #Prompt('Output Filename (Example: <39>FileUse.txt<39>)',EXPR),%FiveOUseTxtOutputFileName
        #Display('Note: Use quotes if not variable.')
        #Display('')
        #Prompt('Use FileManager Open',Check),%FiveOUseFileManagerOpen,Default(1),at(10)
        #Prompt('Use FileManager UseFile',Check),%FiveOUseFileManagerUseFile,Default(0),at(10)
    #EndTab
    #Tab('Multi-DLL')
      #Boxed('')
        #Prompt('This is part of a Multi-DLL program',Check),%MultiDLL,default(%ProgramExtension='DLL'),at(10)
        #Enable(%MultiDLL=1)
          #Enable(%ProgramExtension='DLL')
            #Prompt('Export Class from this DLL',Check),%RootDLL,at(10)
          #EndEnable
        #EndEnable
      #EndBoxed
    #EndTab
    #!#TAB('Classes')
    #!    #Insert(%GlobalDeclareClassesPR)
    #!#ENDTAB
  #endsheet
#AtStart
#IF(not VarExists(%HasStringTheory))
#Declare(%HasStringTheory)
#EndIf
#INSERT(%CheckFor,'StringTheory','Activate_StringTheory(StringTheory)','FiveO')
#IF(VarExists(%StringTheoryTPLVersion))
#SET(%HasStringTheory,1)
#EndIf
#EndAT
#!----------------------------------------------------------------------------------------------------------------------
#AT(%AfterGlobalIncludes),Where(%NoFiveO=0)
   include('dwrTableUsage.inc'),ONCE
#ENDAT
#!----------------------------------------------------------------------------------------------------------------------
#At(%GlobalData),Where(%NoFiveO=0)
#DECLARE(%FileGuidStr)
#!----------------------------------------------------------------------------------------------------------------------
#If(%HasStringTheory=1)
GloSt           StringTheory
#EndIf
#!DLLKillX        Long

#!#If(%MultiDLL=1)
#!    #If(%RootDLL=1)
#!        #FOR(%File)
#!        #SET(%FileGuidStr,%File & 'Guid  String(16)')
#!%FileGuidStr
#!        #EndFor
#!    #EndIf
#!#ElsIf(%MultiDLL=0)
#!    #FOR(%File)
#!    #SET(%FileGuidStr,%File & 'Guid  String(16)')
#!%FileGuidStr
#!    #EndFor
#!#EndIf

#If(%MultiDLL=1)
    #If(%RootDLL=0)
MyFileUse                           dwrTableUsage,External,DLL(_ABCDllMode_) ! Not Threaded
    #ElsIf(%RootDLL=1)
MyFileUse                           CLASS(dwrTableUsage)
InsertUpdateQ                       Procedure(string pFileName),Virtual                                    
                                    End
    #EndIf
#ElsIf(%MultiDLL=0)
MyFileUse                           CLASS(dwrTableUsage)
InsertUpdateQ                       Procedure(string pFileName),Virtual                                    
                                    End
#EndIf

#EndAt
#!----------------------------------------------------------------------------------------------------------------------
#At(%ProgramProcedures),Where(%NoFiveO=0)
#!----------------------------------------------------------------------------------------------------------------------
#EMBED(%BeforeInsertUpdateQProcedure,'Table Use - Before InsertUpdateQ Procedure')
#If(%MultiDLL=1)
    #If(%RootDLL=1)
MyFileUse.InsertUpdateQ            Procedure(string pFileName)
    CODE
    GloSt.Trace('MyFileUse.InsertUpdateQ - File[' & clip(pFileName) & ']')
    #!self.FileUseCountQ.Guid = pGuid
    self.FileUseCountQ.FileName = Clip(pFileName)
    #!Get(self.FileUseCountQ,self.FileUseCountQ.Guid)
    Get(self.FileUseCountQ,self.FileUseCountQ.FileName)
    If Errorcode()
        self.FileUseCountQ.FileName = pFileName
        self.FileUseCountQ.Count = 1
        Add(self.FileUseCountQ)
    ELSE
        self.FileUseCountQ.Count = self.FileUseCountQ.Count + 1
        Put(self.FileUseCountQ)
    End
    #EndIf
#ElsIf(%MultiDLL=0)
MyFileUse.InsertUpdateQ            Procedure(string pFileName)
    CODE
	GloSt.Trace('MyFileUse.InsertUpdateQ - File[' & Clip(pFileName) & ']')
    #!self.FileUseCountQ.Guid = pGuid
    self.FileUseCountQ.FileName = Clip(pFileName)
    #!Get(self.FileUseCountQ,self.FileUseCountQ.Guid)
    Get(self.FileUseCountQ,self.FileUseCountQ.FileName)
    If Errorcode()
        #!elf.FileUseCountQ.Guid = pGuid
        self.FileUseCountQ.FileName = pFileName
        self.FileUseCountQ.Count = 1
        Add(self.FileUseCountQ)
    ELSE
        self.FileUseCountQ.Count = self.FileUseCountQ.Count + 1
        Put(self.FileUseCountQ)
    End
#EndIf
#EMBED(%AfterInsertUpdateQProcedure,'Table Use - After InsertUpdateQ Procedure')
#EndAT
#!----------------------------------------------------------------------------------------------------------------------
#AT(%DLLKillCode),PRIORITY(4000),Where(%NoFiveO=0)
#!----------------------------------------------------------------------------------------------------------------------
#IF(not VarExists(%FileGuidGetStr))
#Declare(%FileGuidGetStr)
#EndIf
#If(%MultiDLL=1)
    #If(%RootDLL=1)
GloSt.Start()
        #FOR(%File)
        #SET(%FileGuidGetStr,%File & 'Guid')
#!MyFileUse.FileUseCountQ.Guid = %FileGuidGetStr
MyFileUse.FileUseCountQ.FileName = '%File'
Get(MyFileUse.FileUseCountQ,MyFileUse.FileUseCountQ.FileName)
If Errorcode()
  GloSt.Append('%File not Used<13,10>')
End
        #EndFor
#If(%FiveOUseTxtOutputFileName='')
    #ASSERT(%False, 'You have not set an output filename.')
#Else
GloSt.SaveFile(%FiveOUseTxtOutputFileName)
#EndIf
    #EndIf
#EndIf
#EndAT
#!----------------------------------------------------------------------------------------------------------------------
#At(%FileManagerCodeSection,,'Open','(),BYTE'),PRIORITY(5501),Where(%NoFiveO=0) 
#!----------------------------------------------------------------------------------------------------------------------
#IF(not VarExists(%GuidParam))
    #Declare(%GuidParam)
#EndIf
#SET(%GuidParam,%File & 'Guid')
#If(%FiveOUseFileManagerOpen=1)
MyFileUse.InsertUpdateQ('%File') #!SELF.FileNameValue SELF.File{PROP:Name}
#EndIf
#EndAt
#!----------------------------------------------------------------------------------------------------------------------
#AT(%FileManagerCodeSection,,'UseFile','(BYTE UseType = UseType:Uses),BYTE'),Where(%NoFiveO=0)
#!----------------------------------------------------------------------------------------------------------------------
#IF(not VarExists(%GuidParam))
    #Declare(%GuidParam)
#EndIf
#SET(%GuidParam,%File & 'Guid')
#If(%FiveOUseFileManagerUseFile=1)
MyFileUse.InsertUpdateQ('%File') #!SELF.FileNameValue SELF.File{PROP:Name}
#EndIf
#EndAt
#!-----------------------------------------------------------------------------------------------------------------------
#EXTENSION(LocalTableUseTracker,'Local Table Usage Tracker'),REQ(GlobalTableUseTracker) #!,Description(' [FiveO] ' &  %ThisObjectName & ' ('&%ABCBaseClass & ')'),Procedure   #!,PROCEDURE,REQ(Activate_FiveO(FiveOTableUseTracker))
#!-----------------------------------------------------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),PRIORITY(1000),Where(%NoFiveO=0)
#IF(not VarExists(%FileGuidGetStr))
#Declare(%FileGuidGetStr)
#EndIf
GloSt.Start()
        #FOR(%File)
        #SET(%FileGuidGetStr,%File & 'Guid')
#!MyFileUse.FileUseCountQ.Guid = %FileGuidGetStr
MyFileUse.FileUseCountQ.FileName = '%File'
Get(MyFileUse.FileUseCountQ,MyFileUse.FileUseCountQ.FileName)
#EMBED(%MyFileUseGet,'Table Use - MyFileUse Get')
If Errorcode()
  GloSt.Append('%File not Used<13,10>')
End
        #EndFor
#If(%FiveOUseTxtOutputFileName='')
    #ASSERT(%False, 'You have not set an output filename.')
#Else
GloSt.SaveFile(%FiveOUseTxtOutputFileName)
#EndIf
#EndAT